#define DEFAULTBITKEYSIZE 2048
#define DEFAULTKEYEXP 65357
#define MAXBITKEYSIZE 4096
#define MAXBYTEKEYSIZE (MAXBITKEYSIZE/8)

#define S(a) do {a;} while (0)

#define _convert_pubkey_(rsapt,pubkeymod,pubkeyexp,cont)        \
S(                                                              \
  BN_hex2bn(&((rsapt)->n), pubkeymod);                          \
  BN_hex2bn(&((rsapt)->e), pubkeyexp);                          \
  if (!((rsapt)->n && (rsapt)->e)) {                            \
    cont;                                                       \
  }                                                             \
)

#define _get_public_key_(fp, rsapt, buf)                \
S(                                                      \
  rewind(fp);						\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->n), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->e), buf);				\
)

#define _get_private_key_(fp, rsapt, buf)		\
S(                                                      \
  (rsapt) = RSA_new();                                  \
  if (!(rsapt)) {                                       \
    perror("_get_private_key_: RSA_new() failed");      \
    exit(1);                                            \
  }                                                     \
  rewind(fp);						\
  (buf)[0] = 0;                                         \
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->n), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->e), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->d), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->p), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->q), buf);				\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->dmp1), buf);			\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->dmq1), buf);			\
  fscanf(fp, "%s", buf);				\
  BN_hex2bn(&(rsapt->iqmp), buf);			\
)

#define _clean_private_key_(rsapt, buf, buflen)         \
S(                                                      \
  memset(buf,0,buflen);                                 \
  RSA_free(rsapt);                                      \
)

#define _RSA_new_(rsapt) S(rsapt = RSA_new())

#define _RSA_free_(rsapt) \
S(\
  if ((rsapt) && (rsapt)->n && (rsapt)->e) {\
    RSA_free(rsapt);\
    rsapt = NULL;\
  }\
)

#define _RSA_copy_(rsaptdest,rsaptsrc,cont) \
do {\
S(\
  rsaptdest = RSA_new();\
  (rsaptdest)->n = BN_dup((rsaptsrc)->n);\
  (rsaptdest)->e = BN_dup((rsaptsrc)->e);\
);\
  if (!((rsaptdest)->n && (rsaptdest)->e)) {\
    _RSA_free_(rsaptdest);\
    cont;\
  }\
} while (0)

#define _BN_bn2hex_(buf,bignum) S(buf = BN_bn2hex(bignum))

#define _OPENSSL_free_(buf) \
S(\
  if (buf) {\
    OPENSSL_free(buf);\
    buf = NULL;\
  } \
)
